/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package v1alpha6

import (
	"net/http"

	v1alpha6 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_openstack/openstack/v1alpha6"
	"gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-openstack/clientset/versioned/scheme"
	rest "k8s.io/client-go/rest"
)

type InfrastructureV1alpha6Interface interface {
	RESTClient() rest.Interface
	OpenStackClustersGetter
	OpenStackClusterTemplatesGetter
	OpenStackMachinesGetter
	OpenStackMachineTemplatesGetter
}

// InfrastructureV1alpha6Client is used to interact with features provided by the infrastructure.cluster.x-k8s.io group.
type InfrastructureV1alpha6Client struct {
	restClient rest.Interface
}

func (c *InfrastructureV1alpha6Client) OpenStackClusters(namespace string) OpenStackClusterInterface {
	return newOpenStackClusters(c, namespace)
}

func (c *InfrastructureV1alpha6Client) OpenStackClusterTemplates(namespace string) OpenStackClusterTemplateInterface {
	return newOpenStackClusterTemplates(c, namespace)
}

func (c *InfrastructureV1alpha6Client) OpenStackMachines(namespace string) OpenStackMachineInterface {
	return newOpenStackMachines(c, namespace)
}

func (c *InfrastructureV1alpha6Client) OpenStackMachineTemplates(namespace string) OpenStackMachineTemplateInterface {
	return newOpenStackMachineTemplates(c, namespace)
}

// NewForConfig creates a new InfrastructureV1alpha6Client for the given config.
// NewForConfig is equivalent to NewForConfigAndClient(c, httpClient),
// where httpClient was generated with rest.HTTPClientFor(c).
func NewForConfig(c *rest.Config) (*InfrastructureV1alpha6Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	httpClient, err := rest.HTTPClientFor(&config)
	if err != nil {
		return nil, err
	}
	return NewForConfigAndClient(&config, httpClient)
}

// NewForConfigAndClient creates a new InfrastructureV1alpha6Client for the given config and http client.
// Note the http client provided takes precedence over the configured transport values.
func NewForConfigAndClient(c *rest.Config, h *http.Client) (*InfrastructureV1alpha6Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientForConfigAndClient(&config, h)
	if err != nil {
		return nil, err
	}
	return &InfrastructureV1alpha6Client{client}, nil
}

// NewForConfigOrDie creates a new InfrastructureV1alpha6Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *InfrastructureV1alpha6Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new InfrastructureV1alpha6Client for the given RESTClient.
func New(c rest.Interface) *InfrastructureV1alpha6Client {
	return &InfrastructureV1alpha6Client{c}
}

func setConfigDefaults(config *rest.Config) error {
	gv := v1alpha6.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = scheme.Codecs.WithoutConversion()

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *InfrastructureV1alpha6Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
